## opengtl 0.9.18

=== CMakeLists.txt ===
project(OpenGTL)

cmake_minimum_required(VERSION 2.6)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )

option(OPENGTL_BUILD_TESTS "Build tests" OFF)
option(OPENGTL_ENABLE_DEBUG_OUTPUT "Enable (heavy) debug output (only do that for debugging OpenGTL" OFF)
option(OPENGTL_ENABLE_DEBUG_THREAD "Test if functions are accessed by different thread" OFF)
option(OPENGTL_FULL_WARNINGS "Build OpenGTL with all warnings" OFF)
option(OPENGTL_CODE_COVERAGE "Activate code coverage for tests" OFF)
option(OVERIDE_LLVM_ASSERT "Use this only for debug purposes, this break thread safety." OFF)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )

set(OPENGTL_VERSION "0.9.18")
set(OPENGTL_LIB_VERSION ${OPENGTL_VERSION})
set(OPENGTL_LIB_SOVERSION "0.8")

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include/)
set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/OpenGTL/)
set(DOC_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/OpenGTL/)
set(GTLIMAGEIO_EXTENSIONS_INSTALL_DIR ${LIB_INSTALL_DIR}/GTLImageIO/Extensions)

#
# Define INSTALL_TARGETS_DEFAULT_ARGS to be used as install target for program and library. It will do the right thing on all platform
#
set(INSTALL_TARGETS_DEFAULT_ARGS  RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
                                  LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
                                  ARCHIVE DESTINATION "${LIB_INSTALL_DIR}" COMPONENT Devel )


# on the Mac support an extra install directory for application bundles starting with cmake 2.6
if(APPLE)
   set(INSTALL_TARGETS_DEFAULT_ARGS  ${INSTALL_TARGETS_DEFAULT_ARGS}
                               BUNDLE DESTINATION "${BUNDLE_INSTALL_DIR}" )
endif(APPLE)


set(OPENGTL_TESTS_DATA "" CACHE FILEPATH "Directory that contains the data of the tests.")

include (TestBigEndian)
test_big_endian(CMAKE_WORDS_BIGENDIAN)
configure_file(config-endian.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-endian.h )

find_package(LLVM REQUIRED)

# Find llvm jit, interpreter and native
if(MSVC)
  set( LLVM_LIBS
      ${LLVM_LIBRARIES_PATH}/LLVMCore.lib
      ${LLVM_LIBRARIES_PATH}/LLVMipo.lib
      ${LLVM_LIBRARIES_PATH}/LLVMInterpreter.lib
      ${LLVM_LIBRARIES_PATH}/LLVMJIT.lib
      ${LLVM_LIBRARIES_PATH}/LLVMExecutionEngine.lib
      ${LLVM_LIBRARIES_PATH}/LLVMLinker.lib
      ${LLVM_LIBRARIES_PATH}/LLVMArchive.lib
      ${LLVM_LIBRARIES_PATH}/LLVMBitReader.lib
      ${LLVM_LIBRARIES_PATH}/LLVMBitWriter.lib
      ${LLVM_LIBRARIES_PATH}/LLVMX86AsmParser.lib
      ${LLVM_LIBRARIES_PATH}/LLVMX86AsmPrinter.lib
      ${LLVM_LIBRARIES_PATH}/LLVMX86CodeGen.lib
      ${LLVM_LIBRARIES_PATH}/LLVMSelectionDAG.lib
      ${LLVM_LIBRARIES_PATH}/LLVMAsmPrinter.lib
      ${LLVM_LIBRARIES_PATH}/LLVMCodeGen.lib
      ${LLVM_LIBRARIES_PATH}/LLVMScalarOpts.lib
      ${LLVM_LIBRARIES_PATH}/LLVMTransformUtils.lib
      ${LLVM_LIBRARIES_PATH}/LLVMipa.lib
      ${LLVM_LIBRARIES_PATH}/LLVMAnalysis.lib
      ${LLVM_LIBRARIES_PATH}/LLVMTarget.lib
      ${LLVM_LIBRARIES_PATH}/LLVMMC.lib
      ${LLVM_LIBRARIES_PATH}/LLVMX86Info.lib
      ${LLVM_LIBRARIES_PATH}/LLVMSupport.lib
      ${LLVM_LIBRARIES_PATH}/LLVMSystem.lib )
else(MSVC)
  FIND_LLVM_LIBS( ${LLVM_CONFIG_EXECUTABLE} "native bitwriter linker bitreader jit interpreter support ipo" LLVM_LIBS LLVM_NATIVE_OBJECTS )
endif(MSVC)

if( NOT MSVC AND NOT (LLVM_VERSION STREQUAL "3.1" OR LLVM_VERSION STREQUAL "3.0" OR LLVM_VERSION STREQUAL "3.2svn"  OR LLVM_VERSION STREQUAL "3.2" ) ) # There is no way with MSVC to know the llvm version
  message(FATAL_ERROR "LLVM 3.0 or 3.1 or 3.2 is required.")
endif()

if(MSVC)
  add_definitions(/FIiso646.h)
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/msvc/build)
  install( FILES msvc/inst/stdint.h DESTINATION ${INCLUDE_INSTALL_DIR} )
  set(LLVM_COMPILED_WITHOUT_ASSERTS true)
  add_definitions(/W0)
endif(MSVC)

find_package(Threads)

if(CMAKE_USE_PTHREADS_INIT)
  set(PTHREAD_FOUND TRUE)
  set(GTLTEST_THREAD_SUPPORT TRUE)
  add_definitions(-DOPENGTL_HAVE_PTHREAD)
  add_definitions(-DGTLTEST_HAVE_THREAD)
  message(STATUS "pthread was found.")
else(CMAKE_USE_PTHREADS_INIT)
  message(STATUS "pthread wasn't found, thread tests won't be available and memory manager will use hash.")
endif(CMAKE_USE_PTHREADS_INIT)

if(OPENGTL_BUILD_TESTS)
  include(CTest)
  add_definitions(-DOPENGTL_ENABLE_TESTS)
endif(OPENGTL_BUILD_TESTS)

if(OPENGTL_ENABLE_DEBUG_OUTPUT)
  add_definitions(-DOPENGTL_ENABLE_DEBUG_OUTPUT)
endif(OPENGTL_ENABLE_DEBUG_OUTPUT)

if(OPENGTL_ENABLE_DEBUG_THREAD)
  add_definitions(-DOPENGTL_ENABLE_DEBUG_THREAD)
endif(OPENGTL_ENABLE_DEBUG_THREAD)

if(NOT LLVM_COMPILED_WITHOUT_ASSERTS)
  if(OVERIDE_LLVM_ASSERT)
    message(STATUS "llvm was build with asserts, this is not supported by OpenGTL but you have enable the overide")
  else()
    message(FATAL_ERROR "llvm was build with asserts, this is not supported by OpenGTL (llvm with asserts is not thread safe).")
  endif()
endif(NOT LLVM_COMPILED_WITHOUT_ASSERTS)

if(OPENGTL_FULL_WARNINGS)
  set(OPENGTL_BUILD_DEFINITION "-Waddress -Warray-bounds -Wc++0x-compat -Wchar-subscripts -Wcomment -Wformat -Wmissing-braces -Wparentheses -Wreorder -Wreturn-type -Wsequence-point -Wsign-compare -Wstrict-aliasing -Wstrict-overflow=1 -Wswitch -Wtrigraphs -Wuninitialized -Wunknown-pragmas -Wunused-function -Wunused-label -Wunused-value -Wvolatile-register-var -Werror -Wno-deprecated-declarations") # -Wall without -Wunused-variable  since it is buggy in gcc 4.6
endif(OPENGTL_FULL_WARNINGS)

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 32 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results32)
  set(OPENGTL_32_BITS TRUE)
  
else(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 64 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results64)
  set(OPENGTL_32_BITS FALSE)
  # check that llvm was build with -fPIC
  if(NOT LLVM_COMPILED_WITH_PIC AND NOT APPLE)
    message(FATAL_ERROR "llvm wasn't build with PIC enabled, this is not surported on 64bits.")
  endif()
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/OpenGTL ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/OpenGTL
)

if(OPENGTL_32_BITS)
  add_definitions( -DOPENGTL_32_BITS )
endif(OPENGTL_32_BITS)

# Test for visibility in gcc

if (CMAKE_COMPILER_IS_GNUCXX AND NOT APPLE)
  include (MacroEnsureVersion)
  include (CheckCXXCompilerFlag)

  # visibility support
  check_cxx_compiler_flag(-fvisibility=hidden __GTL_HAVE_GCC_VISIBILITY)
  set( __GTL_HAVE_GCC_VISIBILITY ${__GTL_HAVE_GCC_VISIBILITY} CACHE BOOL "GCC support for hidden visibility")

   # get the gcc version
   exec_program(${CMAKE_C_COMPILER} ARGS ${CMAKE_C_COMPILER_ARG1} --version OUTPUT_VARIABLE _gcc_version_info)

   string (REGEX MATCH "[345]\\.[0-9]\\.[0-9]" _gcc_version "${_gcc_version_info}")
   # gcc on mac just reports: "gcc (GCC) 3.3 20030304 ..." without the patch level, handle this here:
   if (NOT _gcc_version)
      string (REGEX REPLACE ".*\\(GCC\\).* ([34]\\.[0-9]) .*" "\\1.0" _gcc_version "${_gcc_version_info}")
   endif (NOT _gcc_version)

   macro_ensure_version("4.1.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_1)
   macro_ensure_version("4.2.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_2)
   macro_ensure_version("4.3.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_3)

   # save a little by making local statics not threadsafe
   # ### do not enable it for older compilers, see
   # ### http://gcc.gnu.org/bugzilla/show_bug.cgi?id=31806
   if (GCC_IS_NEWER_THAN_4_3)
       set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-threadsafe-statics")
   endif (GCC_IS_NEWER_THAN_4_3)

   set(_GCC_COMPILED_WITH_BAD_ALLOCATOR FALSE)
   if (GCC_IS_NEWER_THAN_4_1)
      exec_program(${CMAKE_C_COMPILER} ARGS ${CMAKE_C_COMPILER_ARG1} -v OUTPUT_VARIABLE _gcc_alloc_info)
      string(REGEX MATCH "(--enable-libstdcxx-allocator=mt)" _GCC_COMPILED_WITH_BAD_ALLOCATOR "${_gcc_alloc_info}")
   endif (GCC_IS_NEWER_THAN_4_1)

   if (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

      if (GCC_IS_NEWER_THAN_4_2)
          set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
      endif (GCC_IS_NEWER_THAN_4_2)
   else (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)
      set (__GTL_HAVE_GCC_VISIBILITY 0)
   endif (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)

endif ()

# Enable code coverage

if(OPENGTL_CODE_COVERAGE)
    find_program( LCOV lcov )
    find_program( LCOV_GENHTML genhtml )
    if( LCOV )
        set( LCOV_RDIR "${CMAKE_BINARY_DIR}/lcov-report" )
        add_definitions(-fprofile-arcs -ftest-coverage)
        set (CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHARED_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
        set (CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
        add_custom_target( coverage-clean
          COMMAND mkdir -p ${LCOV_RDIR}
          COMMAND ${LCOV} -d ${CMAKE_BINARY_DIR} -z
          COMMAND ${LCOV} -c -i -d ${CMAKE_BINARY_DIR} -o ${LCOV_RDIR}/base.info
        )
        add_custom_target( coverage
          COMMAND mkdir -p ${LCOV_RDIR}
          COMMAND ${LCOV} --quiet -c -d ${CMAKE_BINARY_DIR} -o ${LCOV_RDIR}/base.info
          COMMAND ${LCOV_GENHTML} ${LCOV_RDIR}/base.info -o ${LCOV_RDIR}/html
        )
    else( LCOV )
        message( SEND_ERROR "Could not find LCOV, disabling coverage report generation." )
    endif( LCOV )
endif(OPENGTL_CODE_COVERAGE)

# Add subdirectories

option(OPENGTL_BUILD_OPENRIJN "Build OpenRijn" OFF)

add_subdirectory(OpenGTL)
add_subdirectory(OpenCTL)
add_subdirectory(OpenShiva)
add_subdirectory(Extensions)

if(OPENGTL_BUILD_OPENRIJN)
  add_subdirectory(OpenRijn)
endif(OPENGTL_BUILD_OPENRIJN)

=== Extensions/CMakeLists.txt ===
find_package(PNG )

if( PNG_FOUND )
  add_subdirectory( PngDC )
endif( PNG_FOUND )

add_subdirectory( RawDC )

=== OpenCTL/CMakeLists.txt ===
project(OpenCTL)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

set(CTLC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/ctlc")
set(CTLI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/ctli")
set(CTLTC "${CMAKE_CURRENT_BINARY_DIR}/tools/templatecompiler/ctltc")

set(OPENCTL_VERSION ${OPENGTL_VERSION})
set(OPENCTL_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENCTL_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenCTL)
add_subdirectory(tools)

# After tool to get CTLC variable
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(tests)
endif(OPENGTL_BUILD_TESTS)

=== OpenGTL/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

add_subdirectory(GTLCore)
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(GTLTest)
endif(OPENGTL_BUILD_TESTS)
add_subdirectory(GTLImageIO)
add_subdirectory(tools)
add_subdirectory(GTLFragment)

=== OpenRijn/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

set(RIJNC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/rijnc")
set(SHIVAI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/rijn")
set(RIJNTESTER "${CMAKE_CURRENT_BINARY_DIR}/tools/tester/rijntester")

set(OPENRIJN_VERSION ${OPENGTL_VERSION})
set(OPENRIJN_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENRIJN_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenRijn)
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(tests)
endif(OPENGTL_BUILD_TESTS)
add_subdirectory(tools)

=== OpenShiva/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

set(SHIVAC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/shivac")
set(SHIVA "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/shiva")
set(SHIVATESTER "${CMAKE_CURRENT_BINARY_DIR}/tools/tester/shivatester")


set(OPENSHIVA_VERSION ${OPENGTL_VERSION})
set(OPENSHIVA_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENSHIVA_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenShiva)
add_subdirectory(tools)
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(tests)
endif(OPENGTL_BUILD_TESTS)
add_subdirectory(doc)

=== Extensions/PngDC/CMakeLists.txt ===
include_directories(${PNG_INCLUDE_DIR})

add_definitions( ${OPENGTL_BUILD_DEFINITION} )

set(PNG_DC_SRCS
    PngDC.cpp )

add_library(PngDC SHARED ${PNG_DC_SRCS} )
target_link_libraries(PngDC GTLImageIO ${PNG_LIBRARIES})

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME=\"\\\"PngDC\\\"\" )
add_definitions( ${PNG_DEFINITIONS} )

# Install target
install(TARGETS PngDC  DESTINATION ${GTLIMAGEIO_EXTENSIONS_INSTALL_DIR} )
# install( FILES ImageDC.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO ) # NO REASON TO INSTALL HEADERS FOR NOW

=== Extensions/RawDC/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/libraw )

SET(libraw_LIB_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/libraw/internal/dcraw_common.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/libraw/internal/dcraw_fileio.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/libraw/src/libraw_cxx.cpp
                    ${CMAKE_CURRENT_SOURCE_DIR}/libraw/src/libraw_c_api.cpp
   )

set( RAW_DC_SRCS
     RawDC.cpp )

add_library( RawDC SHARED ${RAW_DC_SRCS} ${libraw_LIB_SRCS} )
target_link_libraries( RawDC GTLImageIO )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME=\"\\\"RawDC\\\"\" )

# Install target
install( TARGETS RawDC  DESTINATION ${GTLIMAGEIO_EXTENSIONS_INSTALL_DIR} )
# install( FILES ImageDC.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO ) # NO REASON TO INSTALL HEADERS FOR NOW

=== OpenCTL/OpenCTL/CMakeLists.txt ===

include_directories( ${LLVM_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/compiler ${CMAKE_CURRENT_BINARY_DIR} )

# List of files 
set(OpenCTL_SRCS
  Debug.cpp
  Module.cpp
  ModulesManager.cpp
  Program.cpp
  Template.cpp
  Version.cpp
# Internal files
  StdLibFunctions.cpp
  compiler/Compiler.cpp
  compiler/LexerNG.cpp
  compiler/ParserNG.cpp
# Template files
  templatecompiler/GenerationContext_p.cpp
  templatecompiler/TemplateAST.cpp
  templatecompiler/TemplateLexer.cpp
  templatecompiler/TemplateParser.cpp
  ${LLVM_NATIVE_OBJECTS}
    )

# Add the OpenCTL library for build
add_library(OpenCTL SHARED ${OpenCTL_SRCS})
target_link_libraries(OpenCTL GTLCore )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( "-D__STDC_CONSTANT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="OpenCTL" )

add_definitions( -D_OPENCTL_LIB_="libOpenCTL.so.${OPENGTL_LIB_SOVERSION}")
add_definitions( -D_OPENCTL_CTL_STD_LIB_SRC_DIR_="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions( -D_OPENCTL_CTL_SHARE_DIR_="${SHARE_INSTALL_DIR}/ctl" )


# Set the ABI version of the library
set_target_properties(OpenCTL PROPERTIES VERSION ${OPENCTL_LIB_VERSION} SOVERSION ${OPENCTL_LIB_SOVERSION} )

# Install target
install(TARGETS OpenCTL ${INSTALL_TARGETS_DEFAULT_ARGS} )
install( FILES
  Export.h
  Module.h
  ModulesManager.h
  Program.h
  Template.h
  Version.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/OpenCTL )

# Create and install pc file
configure_file("OpenCTL.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/OpenCTL.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCTL.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)  

# Install standard library
install(FILES ctlstdlib.ctl DESTINATION ${SHARE_INSTALL_DIR}/ctl )

=== OpenCTL/tests/CMakeLists.txt ===

add_subdirectory(library)
add_subdirectory(parse)
add_subdirectory(stdlib)
add_subdirectory(arithmetic)
add_subdirectory(statements)
add_subdirectory(misc)
add_subdirectory(complextypes)
add_subdirectory(templates)

=== OpenCTL/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)
if(NOT MSVC)
  add_subdirectory(benchmark)
endif(NOT MSVC)
add_subdirectory(templatecompiler)

=== OpenGTL/GTLCore/CMakeLists.txt ===
if(OPENGTL_BUILD_TESTS)
  add_subdirectory(tests)
endif(OPENGTL_BUILD_TESTS)

include_directories( ${LLVM_INCLUDE_DIR} )

## Generate macros.h file

configure_file(Macros.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/Macros.h )

## GTLCore library ##

set(GTLCore_SRCS
  AbstractColorConverter.cpp
  AbstractImage.cpp
  Array.cpp
  Buffer.cpp
  BufferImage.cpp
  Debug.cpp
  ChannelsFlags.cpp
  Color.cpp
  ColorConverters.cpp
  CompilationMessage.cpp
  CompilationMessages.cpp
  Function.cpp
  Image.cpp
  Parameter.cpp
  PixelDescription.cpp
  ProgressReport.cpp
  ScopedName.cpp
  String.cpp
  Transform.cpp
  Type.cpp
  TypesManager.cpp
  Value.cpp
  Value_p.cpp
  Version.cpp
# Internal files
  ChannelMaths.cpp
  CompilerBase_p.cpp
  ConvertCenter_p.cpp
  ErrorMessages_p.cpp
  Function_p.cpp
  FunctionCaller_p.cpp
  FloatHalfConverter_p.cpp
  LexerBase_p.cpp
  MemoryManager_p.cpp
  ModuleData_p.cpp
  OperatorOverloadCenter_p.cpp
  ParserBase_p.cpp
  SharedPointer.cpp
  Token_p.cpp
  Type_p.cpp
  TypesManager_p.cpp
  VariableNG_p.cpp
  VariablesManager_p.cpp
  VirtualMachine_p.cpp
# AST
  AST/AccessorExpression.cpp
  AST/Annotation.cpp
  AST/BinaryExpression.cpp
  AST/ConvertExpression.cpp
  AST/CompoundExpression.cpp
  AST/ConstantCompoundExpression.cpp
  AST/GarbageCollectionStatement.cpp
  AST/GenerationVisitor.cpp
  AST/ExpressionResult.cpp
  AST/Expression.cpp
  AST/FunctionDeclaration.cpp
  AST/Node.cpp
  AST/Statement.cpp
  AST/Tree.cpp
  AST/UnaryExpression.cpp
# ASTBackend
  ASTBackend/ExpressionResult.cpp
  ASTBackend/GenerationVisitor.cpp
# LLVMBackend
  LLVMBackend/CodeGenerator_p.cpp
  LLVMBackend/ContextManager_p.cpp
  LLVMBackend/ExpressionResult_p.cpp
  LLVMBackend/ExpressionGenerationContext_p.cpp
  LLVMBackend/GenerationContext_p.cpp
  LLVMBackend/Visitor_p.cpp
# Metadata
  Metadata/Debug_p.cpp
  Metadata/Entry.cpp
  Metadata/Group.cpp
  Metadata/ParameterEntry.cpp
  Metadata/TextEntry.cpp
  Metadata/ValueEntry.cpp
  Metadata/Factory_p.cpp
# TimeMachine
  TimeController.cpp
  TimeMachine.cpp
  TimeValue_p.cpp
# wrappers
  wrappers/Allocate.cpp
  wrappers/ProgressReportWrap.cpp
  wrappers/TransformWrap_p.cpp
  ${LLVM_NATIVE_OBJECTS}
  )


# Create GTLCore library
add_library(GTLCore SHARED ${GTLCore_SRCS} ${llvm_objects})

if(NOT MSVC AND NOT APPLE)
set(EXTRA_GTLCORE_LINK_OPTIONS -Wl,-u,_ZTVN4llvm3JITE )
elseif(APPLE)
set(EXTRA_GTLCORE_LINK_OPTIONS -Wl,-u,__ZTVN4llvm3JITE )
endif()

target_link_libraries(GTLCore ${LLVM_LDFLAGS} ${LLVM_LIBS} ${EXTRA_GTLCORE_LINK_OPTIONS})

# Set the ABI version of the library
set_target_properties(GTLCore PROPERTIES VERSION ${OPENGTL_LIB_VERSION} SOVERSION ${OPENGTL_LIB_SOVERSION} )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( "-D__STDC_CONSTANT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="GTLCore" )

# installation
install(TARGETS GTLCore ${INSTALL_TARGETS_DEFAULT_ARGS} )
install( FILES
  AbstractImage.h
  Array.h
  Buffer.h
  BufferImage.h
  ChannelsFlags.h
  Color.h
  CompilationMessage.h
  CompilationMessages.h
  Export.h
  Function.h
  ${CMAKE_CURRENT_BINARY_DIR}/Macros.h
  Image.h
  Parameter.h
  PixelDescription.h
  ProgressReport.h
  Region.h
  ScopedName.h
  StdTypes.h
  String.h
  TimeController.h
  TimeMachine.h
  Transform.h
  Type.h
  TypesManager.h
  Value.h
  Version.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore )

install( FILES
  Metadata/ParameterEntry.h
  Metadata/Entry.h
  Metadata/Group.h
  Metadata/TextEntry.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore/Metadata )

# Create and install pc file
configure_file("GTLCore.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/GTLCore.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/GTLCore.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== debian/changelog ===
opengtl (0.9.18-0ubuntu3) vivid; urgency=medium

  * Build-depend on llvm-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Dec 2014 11:37:11 +0100

opengtl (0.9.18-0ubuntu2) vivid; urgency=medium

  * Build using llvm-3.5.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 10 Dec 2014 10:30:05 +0100

opengtl (0.9.18-0ubuntu1) trusty; urgency=medium

  * New upstream version.
  * Build using llvm-3.3.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 15:32:53 +0100

opengtl (0.9.16-0ubuntu3) trusty; urgency=medium

  * Build using llvm-3.2.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 15:17:35 +0100

=== debian/control ===
Source: opengtl
Section: graphics
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Riddell <jriddell@ubuntu.com>
Build-Depends: debhelper (>= 7), cmake, llvm-dev, llvm-3.5-dev, texlive-latex-base, texlive-binaries, imagemagick, libpng-dev, zlib1g-dev, texlive-latex-recommended, pkg-kde-tools
Standards-Version: 3.9.5
Homepage: http://www.opengtl.org/

Package: libgtlcore0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgtlcore0, libgtlcore0.7
Conflicts: libgtlcore0, libgtlcore0.7
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the libgtlcore and libshiva libraries.

Package: libgtlimageio0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgtlcore0, libgtlcore-dev, libgtlimageio0.7
Conflicts: libgtlcore0, libgtlcore-dev, libgtlimageio0.7
Description: Graphics Transformation Libraries Image IO
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the libgtlimageio library.

Package: libgtlfragment0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphics Transformation Libraries Fragment Library
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the libgtlfragment library.

Package: libopenshiva0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libgtlcore0, libopenshiva0.7
Conflicts: libgtlcore0, libopenshiva0.7
Description: Graphics Transformation Libraries Shiva
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 Shiva is a programming language intented to transform an image by
 applying a kernel-like transformation.
 .
 This package contains the libopenshiva library.

Package: libopenctl0.8
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libopenctl0, libopenctl0.7
Conflicts: libopenctl0, libopenctl0.7
Description: OpenCTL from Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the OpenCTL (Colour Transformation Language)
 library.

Package: opengtl-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgtlcore0.8 (= ${binary:Version}), 
 libgtlimageio0.8 (= ${binary:Version}), libopenshiva0.8 (= ${binary:Version}),
 libopenctl0.8 (= ${binary:Version})
Replaces: libgtlcore-dev, libopenctl-dev
Conflicts: libgtlcore-dev, libopenctl-dev
Description: Graphics Transformation Libraries development files
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains development files for OpenGTL libraries.

Package: opengtl-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains some tools that are useful when developing for
 OpenGTL, or to use some of its functionality from the command line:
  - ctlc compile a ctl program
  - ctli execute a function from a ctl program
  - shivac compile a shiva kernel
  - shiva apply a kernel on a set of images

=== debian/rules ===
#!/usr/bin/make -f

export CXXFLAGS="-std=gnu++11"

%:
	dh $@ --parallel
